## pupnp 1.14.18

=== ixml/CMakeLists.txt ===
if (BUILD_TESTING)
	add_subdirectory (test)
endif()

set (IXML_SOURCES
	src/attr.c
	src/document.c
	src/element.c
	src/ixml.c
	src/ixmldebug.c
	src/ixmlmembuf.c
	src/ixmlparser.c
	src/namedNodeMap.c
	src/node.c
	src/nodeList.c
)

list (APPEND IXML_HEADERS
	inc/ixml.h
	inc/ixmldebug.h
)

if (UPNP_BUILD_SHARED)
	add_library (ixml_shared SHARED
		${IXML_SOURCES}
	)

	add_library (IXML::Shared ALIAS ixml_shared)

	set_target_properties (ixml_shared PROPERTIES
		C_VISIBILITY_PRESET "hidden"
		EXPORT_NAME IXML::Shared
		OUTPUT_NAME ixml
		PUBLIC_HEADER "${IXML_HEADERS}"
		SOVERSION ${IXML_VERSION_MAJOR}
		VERSION ${IXML_VERSION_STRING}
	)

	target_compile_definitions (ixml_shared
		PRIVATE $<$<BOOL:${IXML_HAVE_SCRIPTSUPPORT}>:IXML_HAVE_SCRIPTSUPPORT>
		PRIVATE LIBUPNP_EXPORTS
		PUBLIC $<$<BOOL:${MSVC}>:UPNP_USE_MSVCPP>
		PUBLIC $<$<BOOL:${MSVC}>:LIBUPNP_EXPORTS>
		PUBLIC $<$<BOOL:${_LARGE_FILES}>:_LARGE_FILES>
		PUBLIC $<$<BOOL:${_FILE_OFFSET_BITS}>:_FILE_OFFSET_BITS=64>
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
	)

	target_include_directories (ixml_shared
		PRIVATE ${PUPNP_BINARY_DIR}/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_SOURCE_DIR}/upnp/inc/>
	)

	install (TARGETS ixml_shared
		EXPORT IXML
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

if (UPNP_BUILD_STATIC)
	add_library (ixml_static STATIC
		${IXML_SOURCES}
	)

	add_library (IXML::Static ALIAS ixml_static)

	set_target_properties (ixml_static PROPERTIES
		C_VISIBILITY_PRESET "hidden"
		EXPORT_NAME IXML::Static
		OUTPUT_NAME ixml${STATIC_POSTFIX}
		PUBLIC_HEADER "${IXML_HEADERS}"
		SOVERSION ${IXML_VERSION_STRING}
		VERSION ${IXML_VERSION_MAJOR}
	)

	target_compile_definitions (ixml_static
		PRIVATE $<$<BOOL:${IXML_HAVE_SCRIPTSUPPORT}>:IXML_HAVE_SCRIPTSUPPORT>
		PRIVATE LIBUPNP_EXPORTS
		PUBLIC UPNP_STATIC_LIB
		PUBLIC $<$<BOOL:${MSVC}>:UPNP_USE_MSVCPP>
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
		PUBLIC $<$<BOOL:${_LARGE_FILES}>:_LARGE_FILES>
		PUBLIC $<$<BOOL:${_FILE_OFFSET_BITS}>:_FILE_OFFSET_BITS=64> 
	)

	target_include_directories (ixml_static
		PRIVATE ${PUPNP_BINARY_DIR}/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_SOURCE_DIR}/upnp/inc/>
	)

	install (TARGETS ixml_static
		EXPORT IXML
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

install (EXPORT IXML
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/IXML
)

=== debian/changelog ===
pupnp (1:1.14.18-1.1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:49:54 +0000

pupnp (1:1.14.18-1.1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Mar 2024 12:18:17 +0100

pupnp (1:1.14.18-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063296

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 21:24:41 +0000

pupnp (1:1.14.18-1ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Sep 2023 14:38:00 +0200

pupnp (1:1.14.18-1) unstable; urgency=medium

  * New upstream version 1.14.18

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 02 Sep 2023 18:47:27 +0200

pupnp (1:1.14.17-2ubuntu4) mantic; urgency=medium

  * Try to call correct gcc/pkg-config on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Jun 2023 17:36:17 +0200

pupnp (1:1.14.17-2ubuntu2) mantic; urgency=medium

  * Patch also CMakeLists.txt to export LFS_CFLAGS on 32bit architectures.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Jun 2023 11:08:07 +0200

pupnp (1:1.14.17-2ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 14 Jun 2023 10:02:56 +0200

pupnp (1:1.14.17-2) unstable; urgency=medium

  * debian/rules: Fix indep build

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 12 Jun 2023 08:04:46 +0200

pupnp (1:1.14.17-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream version 1.14.17

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 10 Jun 2023 14:48:54 +0200

pupnp (1:1.14.16-1) experimental; urgency=medium

  [ James Cowgill ]
  * d/control: Drop Multi-Arch: same from libupnp-dev
  * d/tests: Replace ADTTMP with AUTOPKGTEST_TMP

  [ Bryan Quigley ]
  * New upstream release 1.14.0

  [ Sebastian Ramacher ]
  * New upstream version 1.14.16
    - Fix CVE-2020-12695 (Closes: #983206)
    - Fix CVE-2021-29462 (Closes: #987326)
    - Fix CVE-2020-13848 (Closes: #962282)
    - Fix CVE-2021-28302 (Closes: #986833)
  * SONAME bump:
    - libixml10 -> libixml11
    - libupnp13 -> libupnp17
  * debian/: Remove explicit version from source package name and Description
  * debian/control:
    - Adopt is part of the Multimedia team (Closes: #1033858)
    - Update homepage
    - Bump Standards-Version
  * debian/: Bump to debhelper compat 13

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 03 Apr 2023 00:16:37 +0200

pupnp-1.8 (1:1.8.4-2ubuntu2) disco; urgency=medium

  * Fix autopkgtest for 32-bit archs.
  * Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
    required by the headers anyway.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 12 Nov 2018 10:41:27 -0800

pupnp-1.8 (1:1.8.4-2) unstable; urgency=medium

  * Upload to unstable.

 -- James Cowgill <jcowgill@debian.org>  Mon, 05 Nov 2018 19:55:05 +0000

pupnp-1.8 (1:1.8.4-1) experimental; urgency=medium

  * New upstream release.
  * Doxyfile: Revert Debian specific changes to doxygen config. None of
    them have any significant benefits.

  * d/changelog: Remove extra whitespace lines.
  * d/compat: Use debhelper compat 11.
  * d/control:
    - d/control: Move Vcs-* repositories to salsa.d.o.
    - d/control: Bump standards to 4.2.1.
  * d/libupnp-doc.*:
    - Move docs to usr/share/doc/libupnp-dev per policy 3.9.7.
  * d/rules:
    - Revert "Implement build targets manually in debian/rules". Newer
      debhelper versions handle this properly.
    - d/rules: Create docs/doxygen directory.

 -- James Cowgill <jcowgill@debian.org>  Sat, 27 Oct 2018 15:42:13 +0100

pupnp-1.8 (1:1.8.3-3) experimental; urgency=medium

  * Rename libupnp1.8-doc to libupnp-doc.
  * Fix Build-Depends-Package in symbols files.
  * Manually bump SONAME of libupnp to libupnp.so.13. Rename libupnp10 to
    libupnp13. (Closes: #882377)

 -- James Cowgill <jcowgill@debian.org>  Sat, 23 Dec 2017 11:39:44 +0000

pupnp-1.8 (1:1.8.3-2) experimental; urgency=medium

  * debian/control:
    - Bump standards version to 4.1.2.
  * debian/patches:
    - Renumber.
    - Add upstream patch to remove inclusion of ThreadPool.h from upnpdebug.h.
      (Closes: #884252)

 -- James Cowgill <jcowgill@debian.org>  Sat, 23 Dec 2017 00:03:52 +0000

pupnp-1.8 (1:1.8.3-1) experimental; urgency=medium

  * New upstream release.

  * debian/changelog:
    - Remove trailing whitespace.
  * debian/control:
    - Rename libupnp1.8-dev to libupnp-dev. (Closes: #873656)
    - Move libupnp-1.8-dev conflicts to breaks.
    - Add versions to breaks and replaces.
    - Remove unnecessary Testsuite: autopkgtest header.
    - Set Rules-Requires-Root: no.
    - Bump standards version to 4.1.1.
  * debian/copyright:
    - Update.
  * debian/patches:
    - Refresh.
  * debian/rules:
    - Implement build targets manually in debian/rules.
    - Don't suppress doxygen log output.

 -- James Cowgill <jcowgill@debian.org>  Tue, 21 Nov 2017 21:23:05 +0000

pupnp-1.8 (1:1.8.2-3) unstable; urgency=medium

  * debian/rules:
    - Build with --enable-reuseaddr option.

 -- James Cowgill <jcowgill@debian.org>  Sat, 23 Sep 2017 18:56:47 +0100

pupnp-1.8 (1:1.8.2-2) unstable; urgency=medium

  * debian/control:


=== debian/control ===
Source: pupnp
Section: net
Priority: optional
Homepage: https://pupnp.github.io/pupnp/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Sebastian Ramacher <sramacher@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 cmake,
 ninja-build,
Build-Depends-Indep:
 doxygen,
 doxygen-latex,
 graphviz,
 texlive-latex-base,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp
Vcs-Git: https://salsa.debian.org/multimedia-team/pupnp.git

Package: libupnp-dev
Architecture: any
Section: libdevel
Depends:
 libixml11t64 (= ${binary:Version}),
 libupnp17t64 (= ${binary:Version}),
 ${misc:Depends}
Suggests: libupnp-doc
Description: Portable SDK for UPnP Devices, version 1.14 (development files)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 The libupnp-dev package contains the header files, documentation and
 debug versions of libraries needed for development of programs using
 uPnP.

Package: libupnp17t64
Provides: ${t64:Provides}
Replaces: libupnp17
Breaks: libupnp17 (<< ${source:Version})
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Portable SDK for UPnP Devices (shared library)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 The libupnp17t64 package contains the runtime library for uPnP.

Package: libixml11t64
Provides: ${t64:Provides}
Replaces: libixml11
Breaks: libixml11 (<< ${source:Version})
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Portable SDK for UPnP Devices (ixml shared library)
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 The libixml10 package contains the runtime libraries for the Linux DOM2
 XML Parser (IXML).

Package: libupnp-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the Portable SDK for UPnP Devices
 The Portable SDK for UPnP Devices (libupnp) provides developers with an
 API and open source code for building control points, devices, and
 bridges that are compliant with Version 1.0 of the Universal Plug and
 Play Device Architecture Specification - see http://www.upnp.org/ for
 specifications.
 .
 This package contains the HTML documentation for the libupnp library
 in /usr/share/doc/libupnp-dev/

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND += -Wl,-z,defs
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake+ninja

execute_after_dh_clean:
	rm -rf docs/doxygen

override_dh_autoreconf:

override_dh_auto_configure-arch:
	dh_auto_configure -- \
		-DUPNP_BUILD_STATIC=OFF

override_dh_auto_configure-indep:

override_dh_auto_build-indep:
	cd docs && doxygen
	$(MAKE) -C docs/doxygen/latex
	find docs/doxygen/html -name "*.md5" -o -name "*.map" -delete

override_dh_auto_install-indep:

# Tests disabled because they access the network.
override_dh_auto_test-arch:
override_dh_auto_test-indep:

## pupnp 1.14.19

=== debian/changelog ===
pupnp (1:1.14.19-2ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.
  * d/p/444.patch
    - cherry-pick upstream fixes for some more cmake warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 May 2024 11:33:02 +0200

pupnp (1:1.14.19-2) unstable; urgency=medium

  * debian/patches: Apply upstream fixes for package version (Closes:
    #1070690)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 09 May 2024 19:02:10 +0200

pupnp (1:1.14.19-1ubuntu2) oracular; urgency=medium

  * Switch pkg-config to pkgconf (to heal i386 autopkgtests)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 May 2024 10:22:01 +0200

pupnp (1:1.14.19-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Fix autopkgtest for 32-bit archs.
    - Fix pkg-config .pc file to always inherit LFS_CFLAGS, since they're
      required by the headers anyway.
  * d/p/443.patch
  * d/p/444.patch
    - cherry-pick upstream fixes for empty version on pkgconf file
      (Closes: #1070690)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 May 2024 12:44:48 +0200

pupnp (1:1.14.19-1) unstable; urgency=medium

  * New upstream version 1.14.19
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 05 May 2024 19:14:43 +0200

## pupnp 1.14.20

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 3.11)
CMAKE_POLICY (VERSION 3.13)

# C++11 is required
# Set here before we create any targets
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include (cmake/CmDaB.cmake)
include (cmake/test-functions.cmake)
include (cmake/autoheader.cmake)

project (PUPNP VERSION ${PUPNP_VERSION_STRING})

include (GNUInstallDirs)
include (cmake/options.cmake)

# Only set library postfix with MSVC toolchain
if (MSVC)
	set (CMAKE_DEBUG_POSTFIX d)
	set (STATIC_POSTFIX s)
endif()

if (EXISTS "${CMAKE_SOURCE_DIR}/.git")
	set (DEFAULT_BUILD_TYPE "Debug")
endif (EXISTS "${CMAKE_SOURCE_DIR}/.git")

# Set the possible values of build type for cmake-gui
if (CMAKE_CONFIGURATION_TYPES)
	set (CMAKE_CONFIGURATION_TYPES "Debug;Release"
		CACHE STRING
		"Semicolon separated list of supported configuration types, only supports debug and release, anything else will be ignored"
		FORCE
	)

	set_property (CACHE CMAKE_CONFIGURATION_TYPES
		PROPERTY STRINGS
		"Debug" "Release"
	)
endif()

if (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message (STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")

	set (CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE
		STRING "Choose the type of build." FORCE
	)
endif()

if (UPNP_ENABLE_OPEN_SSL)
	find_package (OpenSSL REQUIRED)
endif()

#
# Checks for header files (which aren't needed on Win32)
#
include (CheckIncludeFile)

if (NOT WIN32)
	set (HAVE_INET_H arpa/inet.h)
	set (HAVE_FCNTL_H fcntl.h)
	set (HAVE_INTTYPES_H inttypes.h)
	set (HAVE_LIMITS_H limits.h)
	set (HAVE_NETDB_H netdb.h)
	set (HAVE_IN_H netinet/in.h)
	set (HAVE_STDLIB_H stdlib.h)
	set (HAVE_STRING_H string.h)
	set (HAVE_IOCTL_H sys/ioctl.h)
	set (HAVE_TIME_H sys/time.h)
	set (HAVE_SYSLOG_H syslog.h)
	set (HAVE_UNISTD_H unistd.h)

	set (headers
		HAVE_INET_H
		HAVE_FCNTL_H
		HAVE_INTTYPES_H
		HAVE_LIMITS_H
		HAVE_NETDB_H
		HAVE_IN_H
		HAVE_STDLIB_H
		HAVE_STRING_H
		HAVE_IOCTL_H
		HAVE_TIME_H
		HAVE_SYSLOG_H
		HAVE_UNISTD_H
	)

	foreach (header ${headers})
		check_include_file (${${header}} ${header})

		if (NOT ${header})
			message (FATAL_ERROR "Header-file ${${header}} not found")
		endif()
	endforeach()
endif (NOT WIN32)

#
# Checks for typedefs, structures, and compiler characteristics
#
include (TestBigEndian)
test_big_endian (big_endian)
check_include_file (sys/socket.h HAVE_SOCKET_H)
check_include_file (ws2tcpip.h HAVE_WS2TCPIP_H)

if (HAVE_SOCKET_H)
	list (APPEND CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
elseif (HAVE_WS2TCPIP_H)
	list (APPEND CMAKE_EXTRA_INCLUDE_FILES ws2tcpip.h)
endif()

include (CheckTypeSize)
check_type_size (socklen_t SOCKLEN_T)
unset (CMAKE_EXTRA_INCLUDE_FILES)

if (NOT SOCKLEN_T)
	set (socklen_t "int")
endif()
#
# Checks for large-file-sensitivity
#
if (NOT HAVE_OFF_T_SIZE AND NOT MSVC)
	check_type_size (off_t OFF_T_SIZE)
	set (UPNP_LARGEFILE_SENSITIVE FALSE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)

	if (OFF_T_SIZE EQUAL 8)
		message (STATUS "System uses 64 bit, no flags needed")
	else()
		unset (HAVE_OFF_T_SIZE CACHE)
		set (CMAKE_REQUIRED_DEFINITIONS -D_FILE_OFFSET_BITS=64)
		check_type_size (off_t OFF_T_SIZE)

		if (OFF_T_SIZE EQUAL 8)
			message (STATUS "_FILE_OFFSET_BITS=64 needed")
			set (UPNP_LARGEFILE_SENSITIVE TRUE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)
			set (_FILE_OFFSET_BITS 64 CACHE BOOL "Number of bits in a file offset, on hosts where this is settable" FORCE)
		else()
			unset (HAVE_OFF_T_SIZE CACHE)
			set (CMAKE_REQUIRED_DEFINITIONS -D_LARGE_FILES)
			check_type_size (off_t OFF_T_SIZE)

			if (OFF_T_SIZE EQUAL 8)
				message (STATUS "_LARGE_FILES needed")
				set (_LARGE_FILES TRUE CACHE BOOL "Define for large files, on AIX-style hosts." FORCE)
				set (UPNP_LARGEFILE_SENSITIVE TRUE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)
			endif()
		endif()
	endif()
elseif (MSVC)
	set (_LARGE_FILES TRUE CACHE BOOL "Define for large files, on AIX-style hosts." FORCE)
	set (UPNP_LARGEFILE_SENSITIVE TRUE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)
endif()

unset (CMAKE_REQUIRED_DEFINITIONS)
#
# Checks for library functions
#
include (CheckFunctionExists)
check_function_exists (fseeko HAVE_FSEEKO)

if (NOT HAVE_FSEEKO)
	set (CMAKE_REQUIRED_DEFINITIONS _LARGEFILE_SOURCE)
	check_function_exists (fseeko HAVE_FSEEKO)
	unset (CMAKE_REQUIRED_DEFINITIONS)

	if (HAVE_FSEEKO)
		set (_LARGEFILE_SOURCE TRUE CACHE BOOL "Define to 1 to make fseeko visible on some hosts (e.g. glibc 2.2)." FORCE)
	endif()
endif()

check_function_exists (strnlen HAVE_STRNLEN)
check_function_exists (strndup HAVE_STRNDUP)

include(CheckCCompilerFlag)
check_c_compiler_flag(-fmacro-prefix-map=from=to HAVE_MACRO_PREFIX_MAP)

if (Solaris)
	set (CMAKE_REQUIRED_LIBRARIES socket)
	check_function_exists (bind HAVE_SOCKET)
	set (CMAKE_REQUIRED_LIBRARIES rt)
	check_function_exists (sched_getparam HAVE_RT)
	unset (CMAKE_REQUIRED_LIBRARIES)
endif()
#
# Checks for POSIX Threads
#
if (NOT MSVC)
	set (THREADS_PREFER_PTHREAD_FLAG TRUE)
	include (FindThreads)

	if (NOT DOWNLOAD_AND_BUILD_DEPS)
		if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
			add_library (Threads::Shared ALIAS Threads::Threads)
			add_library (Threads::Static ALIAS Threads::Threads)
		else ()
			add_library (Threads::Shared INTERFACE IMPORTED)
			add_library (Threads::Static INTERFACE IMPORTED)

			# The following two blocks replicate the original FindThreads
			if (THREADS_HAVE_PTHREAD_ARG)
				set_property (TARGET Threads::Shared PROPERTY
					INTERFACE_COMPILE_OPTIONS "$<$<COMPILE_LANGUAGE:CUDA>:SHELL:-Xcompiler -pthread>"
												"$<$<NOT:$<COMPILE_LANGUAGE:CUDA>>:-pthread>"
				)

				set_property (TARGET Threads::Static PROPERTY
					INTERFACE_COMPILE_OPTIONS "$<$<COMPILE_LANGUAGE:CUDA>:SHELL:-Xcompiler -pthread>"
												"$<$<NOT:$<COMPILE_LANGUAGE:CUDA>>:-pthread>"
				)
			endif()

			if (CMAKE_THREAD_LIBS_INIT)
				get_target_property (thread_location Threads::Threads INTERFACE_LINK_LIBRARIES)

				set_target_properties(Threads::Shared PROPERTIES
					INTERFACE_LINK_LIBRARIES ${thread_location}
				)

				set_target_properties(Threads::Static PROPERTIES
					INTERFACE_LINK_LIBRARIES ${thread_location}
				)
			endif()
		endif()
	endif()
else()
	find_package (PTHREADS4W CONFIG REQUIRED)
endif()
#
# Determine if pthread_rwlock_t is available
#
if (TARGET Threads::Threads)
	set (CMAKE_EXTRA_INCLUDE_FILES pthread.h)

	if (DOWNLOAD_AND_BUILD_DEPS AND NOT PTHREADS4W_DIR)
		set (CMAKE_REQUIRED_INCLUDES ${PTHREADS4W_SOURCE_DIR})
	else()
		if (NOT Threads_FOUND)
			get_target_property (CMAKE_REQUIRED_INCLUDES Threads::Threads INTERFACE_INCLUDE_DIRECTORIES)
		endif()
	endif()

	check_type_size (pthread_rwlock_t UPNP_USE_RWLOCK)
	unset (CMAKE_EXTRA_INCLUDE_FILES)
	unset (CMAKE_REQUIRED_INCLUDES)
endif()

configure_file (${PUPNP_SOURCE_DIR}/upnp/inc/upnpconfig.h.cm ${PUPNP_BINARY_DIR}/upnp/inc/upnpconfig.h)
configure_file (${PUPNP_SOURCE_DIR}/upnp/sample/common/config_sample.h.cm ${PUPNP_BINARY_DIR}/upnp/sample/common/config_sample.h)
configure_file (${PUPNP_BINARY_DIR}/autoconfig.h.cm ${PUPNP_BINARY_DIR}/autoconfig.h)

add_subdirectory (ixml)
add_subdirectory (upnp)

install (EXPORT UPNP
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP
)

include (CMakePackageConfigHelpers)

configure_package_config_file (
	IXML.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/IXMLConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/IXML
)

write_basic_package_version_file (IXMLConfigVersion.cmake
	VERSION ${IXML_VERSION_STRING}
	COMPATIBILITY SameMajorVersion
)

configure_package_config_file (
	UPNP.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/UPNPConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP
)

write_basic_package_version_file (UPNPConfigVersion.cmake
	VERSION ${UPNP_VERSION_STRING}
	COMPATIBILITY SameMajorVersion
)

install (FILES
	${CMAKE_CURRENT_BINARY_DIR}/IXMLConfig.cmake
	${CMAKE_CURRENT_BINARY_DIR}/IXMLConfigVersion.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/IXML/
)

install (FILES
	${CMAKE_CURRENT_BINARY_DIR}/UPNPConfig.cmake
	${CMAKE_CURRENT_BINARY_DIR}/UPNPConfigVersion.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP/
)

set (VERSION ${PUPNP_VERSION_STRING})
set (prefix ${CMAKE_INSTALL_PREFIX})
set (exec_prefix "\${prefix}")
set (libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
set (includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
set (PTHREAD_CFLAGS ${CMAKE_THREAD_LIBS_INIT})

if (UPNP_ENABLE_OPEN_SSL)
	set (OPENSSL_LIBS "-lssl")
endif()

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/libupnp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libupnp.pc @ONLY)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/libupnp.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

if (BUILD_TESTING)
	enable_testing()
	find_package (GTest CONFIG)

	if (GTest_FOUND)
		add_subdirectory (gtest)
	endif()
endif()

if(FUZZER)
	if (NOT CMAKE_C_COMPILER_ID STREQUAL "Clang")
		message(FATAL_ERROR "Compiling with clang is required for libFuzzer")
	endif()
	add_subdirectory(fuzzer)

endif()

=== upnp/generator/Makefile ===
CFLAGS=-Wall

generator: generator.o

clean:
	rm -f generator.o generator 2> /dev/null

=== debian/changelog ===
pupnp (1:1.14.20-1) unstable; urgency=medium

  * New upstream version 1.14.20
  * debian/patches: Remove patches from upstream
  * debian/*.symbols: Add new symbols

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 15 Dec 2024 19:06:48 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,7 @@
 Section: net
 Priority: optional
 Homepage: https://pupnp.github.io/pupnp/
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Sebastian Ramacher <sramacher@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5),
@@ -16,7 +15,7 @@
  graphviz,
  texlive-latex-base,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp
 Vcs-Git: https://salsa.debian.org/multimedia-team/pupnp.git

## pupnp 1.14.20-1+11.0trisquel1

=== debian/changelog ===
pupnp (1:1.14.20-1+11.0trisquel1) aramo-backports; urgency=medium

  * Imported into trisquel backports as part of jami dependency.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 18 Dec 2024 06:43:34 +0000

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: net
 Priority: optional
 Homepage: https://pupnp.github.io/pupnp/
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders:
  Sebastian Ramacher <sramacher@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5),
+Build-Depends: dpkg-dev (>= 1.21.1ubuntu2.3),
  debhelper-compat (= 13),
  cmake,
  ninja-build,

## pupnp 1.14.24

=== debian/changelog ===
pupnp (1:1.14.24-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 06 Aug 2025 12:36:18 +0200

pupnp (1:1.14.24-1) experimental; urgency=medium

  * New upstream version 1.14.24

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 19 Jun 2025 18:54:29 +0200

pupnp (1:1.14.23-1) experimental; urgency=medium

  * New upstream version 1.14.23
  * debian/control:
    - Bump Standards-Version
    - Fix descriptions

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 09 Jun 2025 21:52:36 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: net
 Priority: optional
 Homepage: https://pupnp.github.io/pupnp/
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Sebastian Ramacher <sramacher@debian.org>
-Build-Depends: dpkg-dev (>= 1.21.1ubuntu2.3),
+Build-Depends:
+ dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
  ninja-build,
@@ -15,7 +16,7 @@
  graphviz,
  texlive-latex-base,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp
 Vcs-Git: https://salsa.debian.org/multimedia-team/pupnp.git
 
@@ -34,7 +35,7 @@
  Play Device Architecture Specification - see http://www.upnp.org/ for
  specifications.
  .
- The libupnp-dev package contains the header files, documentation and
+ This package contains the header files, documentation and
  debug versions of libraries needed for development of programs using
  uPnP.
 
@@ -54,7 +55,7 @@
  Play Device Architecture Specification - see http://www.upnp.org/ for
  specifications.
  .
- The libupnp17t64 package contains the runtime library for uPnP.
+ This package contains the runtime library for uPnP.
 
 Package: libixml11t64
 Provides: ${t64:Provides}
@@ -72,7 +73,7 @@
  Play Device Architecture Specification - see http://www.upnp.org/ for
  specifications.
  .
- The libixml10 package contains the runtime libraries for the Linux DOM2
+ This package contains the runtime libraries for the Linux DOM2
  XML Parser (IXML).
 
 Package: libupnp-doc

## pupnp 1.14.25

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.11)
CMAKE_POLICY(VERSION 3.13)

# C++14 is required
# Set here before we create any targets
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(cmake/CmDaB.cmake)
include(cmake/test-functions.cmake)
include(cmake/autoheader.cmake)

project(PUPNP VERSION ${PUPNP_VERSION_STRING})

include(GNUInstallDirs)
include(cmake/options.cmake)

# Only set library postfix with MSVC toolchain
if(MSVC)
	set(CMAKE_DEBUG_POSTFIX d)
	set(STATIC_POSTFIX s)
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
	set(DEFAULT_BUILD_TYPE "Debug")
endif(EXISTS "${CMAKE_SOURCE_DIR}/.git")

# Set the possible values of build type for cmake-gui
if(CMAKE_CONFIGURATION_TYPES)
	set(CMAKE_CONFIGURATION_TYPES "Debug;Release"
		CACHE STRING
		"Semicolon separated list of supported configuration types, only supports debug and release, anything else will be ignored"
		FORCE
	)

	set_property(CACHE CMAKE_CONFIGURATION_TYPES
		PROPERTY STRINGS
		"Debug" "Release"
	)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
	message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")

	set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE
		STRING "Choose the type of build." FORCE
	)
endif()

if(UPNP_ENABLE_OPEN_SSL)
	find_package(OpenSSL REQUIRED)
endif()

#
# Checks for header files (which aren't needed on Win32)
#
include(CheckIncludeFile)

if(NOT WIN32)
	set(HAVE_INET_H arpa/inet.h)
	set(HAVE_FCNTL_H fcntl.h)
	set(HAVE_INTTYPES_H inttypes.h)
	set(HAVE_LIMITS_H limits.h)
	set(HAVE_NETDB_H netdb.h)
	set(HAVE_IN_H netinet/in.h)
	set(HAVE_STDLIB_H stdlib.h)
	set(HAVE_STRING_H string.h)
	set(HAVE_IOCTL_H sys/ioctl.h)
	set(HAVE_TIME_H sys/time.h)
	set(HAVE_SYSLOG_H syslog.h)
	set(HAVE_UNISTD_H unistd.h)

	set(headers
		HAVE_INET_H
		HAVE_FCNTL_H
		HAVE_INTTYPES_H
		HAVE_LIMITS_H
		HAVE_NETDB_H
		HAVE_IN_H
		HAVE_STDLIB_H
		HAVE_STRING_H
		HAVE_IOCTL_H
		HAVE_TIME_H
		HAVE_SYSLOG_H
		HAVE_UNISTD_H
	)

	foreach(header ${headers})
		check_include_file(${${header}} ${header})

		if(NOT ${header})
			message(FATAL_ERROR "Header-file ${${header}} not found")
		endif()
	endforeach()
endif(NOT WIN32)

#
# Checks for typedefs, structures, and compiler characteristics
#
include(TestBigEndian)
test_big_endian(big_endian)
check_include_file(sys/socket.h HAVE_SOCKET_H)
check_include_file(ws2tcpip.h HAVE_WS2TCPIP_H)

if(HAVE_SOCKET_H)
	list(APPEND CMAKE_EXTRA_INCLUDE_FILES sys/socket.h)
elseif(HAVE_WS2TCPIP_H)
	list(APPEND CMAKE_EXTRA_INCLUDE_FILES ws2tcpip.h)
endif()

include(CheckTypeSize)
check_type_size(socklen_t SOCKLEN_T)
unset(CMAKE_EXTRA_INCLUDE_FILES)

if(NOT SOCKLEN_T)
	set(socklen_t "int")
endif()

#
# Checks for large-file-sensitivity
#
if(NOT HAVE_OFF_T_SIZE AND NOT MSVC)
	check_type_size(off_t OFF_T_SIZE)
	set(UPNP_LARGEFILE_SENSITIVE FALSE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)

	if(OFF_T_SIZE EQUAL 8)
		message(STATUS "System uses 64 bit, no flags needed")
	else()
		unset(HAVE_OFF_T_SIZE CACHE)
		set(CMAKE_REQUIRED_DEFINITIONS -D_FILE_OFFSET_BITS=64)
		check_type_size(off_t OFF_T_SIZE)

		if(OFF_T_SIZE EQUAL 8)
			message(STATUS "_FILE_OFFSET_BITS=64 needed")
			set(UPNP_LARGEFILE_SENSITIVE TRUE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)
			set(_FILE_OFFSET_BITS 64 CACHE BOOL "Number of bits in a file offset, on hosts where this is settable" FORCE)
		else()
			unset(HAVE_OFF_T_SIZE CACHE)
			set(CMAKE_REQUIRED_DEFINITIONS -D_LARGE_FILES)
			check_type_size(off_t OFF_T_SIZE)

			if(OFF_T_SIZE EQUAL 8)
				message(STATUS "_LARGE_FILES needed")
				set(_LARGE_FILES TRUE CACHE BOOL "Define for large files, on AIX-style hosts." FORCE)
				set(UPNP_LARGEFILE_SENSITIVE TRUE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)
			endif()
		endif()
	endif()
elseif(MSVC)
	set(_LARGE_FILES TRUE CACHE BOOL "Define for large files, on AIX-style hosts." FORCE)
	set(UPNP_LARGEFILE_SENSITIVE TRUE CACHE BOOL "whether the system defaults to 32bit off_t but can do 64bit when requested" FORCE)
endif()

unset(CMAKE_REQUIRED_DEFINITIONS)

#
# Checks for library functions
#
include(CheckFunctionExists)
check_function_exists(fseeko HAVE_FSEEKO)

if(NOT HAVE_FSEEKO)
	set(CMAKE_REQUIRED_DEFINITIONS _LARGEFILE_SOURCE)
	check_function_exists(fseeko HAVE_FSEEKO)
	unset(CMAKE_REQUIRED_DEFINITIONS)

	if(HAVE_FSEEKO)
		set(_LARGEFILE_SOURCE TRUE CACHE BOOL "Define to 1 to make fseeko visible on some hosts (e.g. glibc 2.2)." FORCE)
	endif()
endif()

check_function_exists(strnlen HAVE_STRNLEN)
check_function_exists(strndup HAVE_STRNDUP)

include(CheckCCompilerFlag)
check_c_compiler_flag(-fmacro-prefix-map=from=to HAVE_MACRO_PREFIX_MAP)

if(Solaris)
	set(CMAKE_REQUIRED_LIBRARIES socket)
	check_function_exists(bind HAVE_SOCKET)
	set(CMAKE_REQUIRED_LIBRARIES rt)
	check_function_exists(sched_getparam HAVE_RT)
	unset(CMAKE_REQUIRED_LIBRARIES)
endif()

#
# Checks for POSIX Threads
#
if(NOT MSVC)
	set(THREADS_PREFER_PTHREAD_FLAG TRUE)
	include(FindThreads)

	if(NOT DOWNLOAD_AND_BUILD_DEPS)
		if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.18)
			add_library(Threads::Shared ALIAS Threads::Threads)
			add_library(Threads::Static ALIAS Threads::Threads)
		else()
			add_library(Threads::Shared INTERFACE IMPORTED)
			add_library(Threads::Static INTERFACE IMPORTED)

			# The following two blocks replicate the original FindThreads
			if(THREADS_HAVE_PTHREAD_ARG)
				set_property(TARGET Threads::Shared PROPERTY
					INTERFACE_COMPILE_OPTIONS "$<$<COMPILE_LANGUAGE:CUDA>:SHELL:-Xcompiler -pthread>"
					"$<$<NOT:$<COMPILE_LANGUAGE:CUDA>>:-pthread>"
				)

				set_property(TARGET Threads::Static PROPERTY
					INTERFACE_COMPILE_OPTIONS "$<$<COMPILE_LANGUAGE:CUDA>:SHELL:-Xcompiler -pthread>"
					"$<$<NOT:$<COMPILE_LANGUAGE:CUDA>>:-pthread>"
				)
			endif()

			if(CMAKE_THREAD_LIBS_INIT)
				get_target_property(thread_location Threads::Threads INTERFACE_LINK_LIBRARIES)

				set_target_properties(Threads::Shared PROPERTIES
					INTERFACE_LINK_LIBRARIES ${thread_location}
				)

				set_target_properties(Threads::Static PROPERTIES
					INTERFACE_LINK_LIBRARIES ${thread_location}
				)
			endif()
		endif()
	endif()
else()
	find_package(PTHREADS4W CONFIG REQUIRED)
endif()

#
# Determine if pthread_rwlock_t is available
#
if(TARGET Threads::Threads)
	set(CMAKE_EXTRA_INCLUDE_FILES pthread.h)

	if(DOWNLOAD_AND_BUILD_DEPS AND NOT PTHREADS4W_DIR)
		set(CMAKE_REQUIRED_INCLUDES ${PTHREADS4W_SOURCE_DIR})
	else()
		if(NOT Threads_FOUND)
			get_target_property(CMAKE_REQUIRED_INCLUDES Threads::Threads INTERFACE_INCLUDE_DIRECTORIES)
		endif()
	endif()

	check_type_size(pthread_rwlock_t UPNP_USE_RWLOCK)
	unset(CMAKE_EXTRA_INCLUDE_FILES)
	unset(CMAKE_REQUIRED_INCLUDES)
endif()

configure_file(${PUPNP_SOURCE_DIR}/upnp/inc/upnpconfig.h.cm ${PUPNP_BINARY_DIR}/upnp/inc/upnpconfig.h)
configure_file(${PUPNP_SOURCE_DIR}/upnp/sample/common/config_sample.h.cm ${PUPNP_BINARY_DIR}/upnp/sample/common/config_sample.h)
configure_file(${PUPNP_BINARY_DIR}/autoconfig.h.cm ${PUPNP_BINARY_DIR}/autoconfig.h)

add_subdirectory(ixml)
add_subdirectory(upnp)

install(EXPORT UPNP
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP
)

include(CMakePackageConfigHelpers)

configure_package_config_file(
	IXML.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/IXMLConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/IXML
)

write_basic_package_version_file(IXMLConfigVersion.cmake
	VERSION ${IXML_VERSION_STRING}
	COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
	UPNP.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/UPNPConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP
)

write_basic_package_version_file(UPNPConfigVersion.cmake
	VERSION ${UPNP_VERSION_STRING}
	COMPATIBILITY SameMajorVersion
)

install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/IXMLConfig.cmake
	${CMAKE_CURRENT_BINARY_DIR}/IXMLConfigVersion.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/IXML/
)

install(FILES
	${CMAKE_CURRENT_BINARY_DIR}/UPNPConfig.cmake
	${CMAKE_CURRENT_BINARY_DIR}/UPNPConfigVersion.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP/
)

set(VERSION ${PUPNP_VERSION_STRING})
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
set(PTHREAD_CFLAGS ${CMAKE_THREAD_LIBS_INIT})

if(UPNP_ENABLE_OPEN_SSL)
	set(OPENSSL_LIBS "-lssl")
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libupnp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libupnp.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libupnp.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

if(BUILD_TESTING)
	enable_testing()
	find_package(GTest CONFIG)

	if(GTest_FOUND)
		add_subdirectory(gtest)
	endif()
endif()

if(FUZZER)
	if(NOT CMAKE_C_COMPILER_ID STREQUAL "Clang")
		message(WARNING "CMAKE_C_COMPILER_ID = ${CMAKE_C_COMPILER_ID}")
		message(FATAL_ERROR "Compiling with clang is required for libFuzzer")
	endif()

	add_subdirectory(fuzzer)
endif()

=== fuzzer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)

project(fuzzer LANGUAGES C)
add_executable(FuzzIxml FuzzIxml.c)

if(NOT DEFINED LOCAL_RUN)
	message("LOCAL_RUN is not defined")

	# GitHub Actions needs this like that
	target_link_libraries(FuzzIxml ixml_static ${LIB_FUZZING_ENGINE})
else()
	message("LOCAL_RUN is ${LOCAL_RUN}")

	set(MY_CUSTOM_PATH ..)
	find_library(LIB_IXML ixml REQUIRED NO_DEFAULT_PATH PATHS ${MY_CUSTOM_PATH}/ixml/.libs)
	set(LIB_UPNP_INCLUDE ${MY_CUSTOM_PATH}/upnp/inc)
	set(LIB_IXML_INCLUDE ${MY_CUSTOM_PATH}/ixml/inc)

	target_include_directories(FuzzIxml PUBLIC
		${LIB_UPNP_INCLUDE}
		${LIB_IXML_INCLUDE})
	target_link_libraries(FuzzIxml PRIVATE
		${LIB_IXML} ${LIB_FUZZING_ENGINE})
endif()

=== gtest/CMakeLists.txt ===
include (GoogleTest)

UPNP_addGTest (test_template test_template.cpp
	ADDITIONAL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../upnp/src/threadutil/
)

#UPNP_addGTest (test_UpnpHttpHeaderList test_UpnpHttpHeaderList.cpp
#	ADDITIONAL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../upnp/src/threadutil/
#)

#if (NOT WIN32)
#	UPNP_addGTest (test_upnpapi test_upnpapi.cpp
#		ADDITIONAL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/../upnp/src/threadutil/
#	)
#endif()

=== upnp/CMakeLists.txt ===
# Only set library prefix with MSVC toolchain
if (MSVC)
	set (WIN_PREFIX "lib")
endif()

if (UPNP_BUILD_SAMPLES)
	add_subdirectory (sample)
endif()

set (UPNP_SOURCES
	src/api/upnpapi.c
	src/api/upnpdebug.c
	src/api/UpnpActionComplete.c
	src/api/UpnpActionRequest.c
	src/api/UpnpDiscovery.c
	src/api/UpnpEvent.c
	src/api/UpnpEventSubscribe.c
	src/api/UpnpExtraHeaders.c
	src/api/UpnpFileInfo.c
	src/api/UpnpStateVarComplete.c
	src/api/UpnpStateVarRequest.c
	src/api/UpnpString.c
	src/api/UpnpSubscriptionRequest.c
	src/genlib/client_table/GenlibClientSubscription.c
	src/genlib/client_table/client_table.c
	src/genlib/miniserver/miniserver.c
	src/genlib/net/sock.c
	src/genlib/net/http/httpparser.c
	src/genlib/net/http/httpreadwrite.c
	src/genlib/net/http/parsetools.c
	src/genlib/net/http/statcodes.c
	src/genlib/net/http/webserver.c
	src/genlib/net/uri/uri.c
	src/genlib/service_table/service_table.c
	src/genlib/util/list.c
	src/genlib/util/membuffer.c
	src/genlib/util/strintmap.c
	src/genlib/util/util.c
	src/threadutil/FreeList.c
	src/threadutil/LinkedList.c
	src/threadutil/ThreadPool.c
	src/threadutil/TimerThread.c
	src/urlconfig/urlconfig.c
)

if (UPNP_ENABLE_GENA)
	list (APPEND UPNP_SOURCES
		src/gena/gena_device.c
		src/gena/gena_ctrlpt.c
		src/gena/gena_callback2.c
	)
endif()

if (UPNP_ENABLE_SOAP)
	list (APPEND UPNP_SOURCES
		src/soap/soap_device.c
		src/soap/soap_ctrlpt.c
		src/soap/soap_common.c
	)
endif()

if (UPNP_ENABLE_SSDP)
	list (APPEND UPNP_SOURCES
		src/ssdp/SSDPResultData.c
		src/ssdp/SSDPResultDataCallback.c
		src/ssdp/ssdp_device.c
		src/ssdp/ssdp_ctrlpt.c
		src/ssdp/ssdp_server.c
	)
endif()

if (UPNP_ENABLE_GENA OR UPNP_ENABLE_OPTIONAL_SSDP_HEADERS)
	list (APPEND UPNP_SOURCES
		src/uuid/md5.c
		src/uuid/sysdep.c
		src/uuid/uuid.c
	)
endif()

list (APPEND UPNP_HEADERS
	inc/Callback.h
	inc/list.h
	inc/upnp.h
	inc/UpnpActionComplete.h
	inc/UpnpActionRequest.h
	inc/UpnpDiscovery.h
	inc/UpnpEvent.h
	inc/UpnpEventSubscribe.h
	inc/UpnpExtraHeaders.h
	inc/UpnpFileInfo.h
	inc/UpnpGlobal.h
	inc/UpnpInet.h
	inc/UpnpIntTypes.h
	inc/UpnpStateVarComplete.h
	inc/UpnpStateVarRequest.h
	inc/UpnpStdInt.h
	inc/UpnpString.h
	inc/UpnpSubscriptionRequest.h
	inc/UpnpUniStd.h
	${PUPNP_BINARY_DIR}/upnp/inc/upnpconfig.h
)

if (UPNP_ENABLE_HELPER_API_TOOLS)
	list (APPEND UPNP_SOURCES
		src/api/upnptools.c
	)

	list (APPEND UPNP_HEADERS
		inc/upnptools.h
	)
endif()

if (UPNP_BUILD_SHARED)
	add_library (upnp_shared SHARED
		${UPNP_SOURCES}
	)

	add_library (UPNP::Shared ALIAS upnp_shared)

	set_target_properties (upnp_shared PROPERTIES
		C_VISIBILITY_PRESET "hidden"
		EXPORT_NAME UPNP::Shared
		OUTPUT_NAME ${WIN_PREFIX}upnp
		PUBLIC_HEADER "${UPNP_HEADERS}"
		SOVERSION ${UPNP_VERSION_MAJOR}
		VERSION ${UPNP_VERSION_STRING}
	)

	target_compile_definitions (upnp_shared
		PRIVATE $<$<CONFIG:Debug>:STATS>
		PRIVATE LIBUPNP_EXPORTS
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
	)

	target_compile_options (upnp_shared
		PRIVATE $<$<BOOL:${HAVE_MACRO_PREFIX_MAP}>:-fmacro-prefix-map=${CMAKE_SOURCE_DIR}/=.>
	)

	target_include_directories (upnp_shared
		PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src/threadutil/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/upnp/inc/>
	)

	target_link_libraries (upnp_shared
		PRIVATE $<$<BOOL:${UPNP_ENABLE_OPEN_SSL}>:OpenSSL::SSL>
		PRIVATE $<$<PLATFORM_ID:Windows>:ws2_32>
		PRIVATE $<$<PLATFORM_ID:Windows>:iphlpapi>
		PUBLIC ixml_shared
		PUBLIC Threads::Shared
	)

	install (TARGETS upnp_shared
		EXPORT UPNP
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

if (UPNP_BUILD_STATIC)
	add_library (upnp_static STATIC
		${UPNP_SOURCES}
	)

	add_library (UPNP::Static ALIAS upnp_static)

	set_target_properties (upnp_static PROPERTIES
		C_VISIBILITY_PRESET "hidden"
		EXPORT_NAME UPNP::Static
		OUTPUT_NAME ${WIN_PREFIX}upnp${STATIC_POSTFIX}
		PUBLIC_HEADER "${UPNP_HEADERS}"
		SOVERSION ${UPNP_VERSION_STRING}
		VERSION ${UPNP_VERSION_MAJOR}
	)

	target_compile_definitions (upnp_static
		PRIVATE UPNP_STATIC_LIB
		PRIVATE LIBUPNP_EXPORTS
		PRIVATE $<$<CONFIG:Debug>:STATS>
		PUBLIC $<IF:$<CONFIG:Debug>,DEBUG,NDEBUG>
	)

	target_compile_options (upnp_static
		PRIVATE $<$<BOOL:${HAVE_MACRO_PREFIX_MAP}>:-fmacro-prefix-map=${CMAKE_SOURCE_DIR}/=.>
	)

	target_include_directories (upnp_static
		PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/src/threadutil/
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc/>
		PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src/inc/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/>
		PUBLIC $<BUILD_INTERFACE:${PUPNP_BINARY_DIR}/upnp/inc/>
	)

	target_link_libraries (upnp_static
		PRIVATE $<$<BOOL:${UPNP_ENABLE_OPEN_SSL}>:OpenSSL::SSL>
		PRIVATE $<$<PLATFORM_ID:Windows>:ws2_32>
		PRIVATE $<$<PLATFORM_ID:Windows>:iphlpapi>
		PUBLIC ixml_static
		PUBLIC Threads::Static
	)

	install (TARGETS upnp_static
		EXPORT UPNP
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_Development
		INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			COMPONENT UPNP_RunTime
			NAMELINK_COMPONENT UPNP_Development
		PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/upnp
			COMPONENT UPNP_Development
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			COMPONENT UPNP_RunTime
	)
endif()

install (EXPORT UPNP
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/UPNP
)

if (BUILD_TESTING)
	enable_testing()
	add_subdirectory (test)
endif()

=== upnp/sample/CMakeLists.txt ===
if (UPNP_BUILD_SHARED)
	set (UPNP_LIBRARY upnp_shared)
else ()
	set (UPNP_LIBRARY upnp_static)
endif()

if (UPNP_ENABLE_CLIENT_API)
	add_executable (tv_ctrlpt
		common/sample_util.c
		common/tv_ctrlpt.c
		linux/tv_ctrlpt_main.c
	)

	target_include_directories (tv_ctrlpt
		PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/common
		PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/common
	)

	target_link_libraries (tv_ctrlpt
		${UPNP_LIBRARY}
	)

	install (TARGETS tv_ctrlpt
		DESTINATION ${CMAKE_INSTALL_BINDIR}
		COMPONENT UPNP_samples
	)
endif()

if (UPNP_ENABLE_CLIENT_API AND UPNP_ENABLE_DEVICE_API)
	add_executable (tv_combo
		common/sample_util.c
		common/tv_ctrlpt.c
		common/tv_device.c
		linux/tv_combo_main.c
	)

	target_include_directories (tv_combo
		PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/common
		PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/common
	)

	target_link_libraries (tv_combo
		${UPNP_LIBRARY}
	)

	install (TARGETS tv_combo
		DESTINATION ${CMAKE_INSTALL_BINDIR}
		COMPONENT UPNP_samples
	)
endif()

if (UPNP_ENABLE_DEVICE_API)
	add_executable (tv_device
		common/sample_util.c
		common/tv_device.c
		linux/tv_device_main.c
	)

	target_include_directories (tv_device
		PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/common
		PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/common
	)

	target_link_libraries (tv_device
		${UPNP_LIBRARY}
	)

	install (TARGETS tv_device
		DESTINATION ${CMAKE_INSTALL_BINDIR}
		COMPONENT UPNP_samples
	)

	install (DIRECTORY web/
		DESTINATION ${CMAKE_INSTALL_DATADIR}/upnp
		COMPONENT UPNP_samples
	)
endif()

=== upnp/test/CMakeLists.txt ===
UPNP_addUnitTest (test-upnp-init test_init.c)
UPNP_addUnitTest (test-upnp-list test_list.c)
UPNP_addUnitTest (test-upnp-log test_log.c)
UPNP_addUnitTest (test-upnp-url test_url.c)

=== debian/changelog ===
pupnp (1:1.14.25-1) unstable; urgency=medium

  * New upstream version 1.14.25

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 26 Sep 2025 13:00:28 +0200

pupnp (1:1.14.24-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Edit tests/control, migrate from pkg-config to pkgconf

  [ Sebastian Ramacher ]
  * debian/control: Remove dependencies to build PDF
  * debian/: Stop building PDF documentation (Closes: #1114272, #1113429)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 07 Sep 2025 21:42:38 +0200

=== debian/control ===
--- 
+++ 
@@ -12,9 +12,7 @@
  ninja-build,
 Build-Depends-Indep:
  doxygen,
- doxygen-latex,
  graphviz,
- texlive-latex-base,
 Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/multimedia-team/pupnp

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,6 @@
 
 override_dh_auto_build-indep:
 	cd docs && doxygen
-	$(MAKE) -C docs/doxygen/latex
 	find docs/doxygen/html -name "*.md5" -o -name "*.map" -delete
 
 override_dh_auto_install-indep:

=== debian/tests/control ===
Tests: build
Depends: build-essential, libupnp-dev, pkgconf

=== debian/watch ===
version=4
https://github.com/pupnp/pupnp/tags .*/release-@ANY_VERSION@@ARCHIVE_EXT@
